/* ===============================================
  OPEN CLOSE Menu
============================================= */

function photo_gallery_open_menu() {
  jQuery('button.menu-toggle').addClass('close-panal');
  setTimeout(function(){
    jQuery('nav#main-menu').show();
  }, 100);

  return false;
}

jQuery( "button.menu-toggle").on("click", photo_gallery_open_menu);

function photo_gallery_close_menu() {
  jQuery('button.close-menu').removeClass('close-panal');
  jQuery('nav#main-menu').hide();
}

jQuery( "button.close-menu").on("click", photo_gallery_close_menu);

/* ===============================================
  TRAP TAB FOCUS ON MODAL MENU
============================================= */

jQuery('button.close-menu').on('keydown', function (e) {
  if (jQuery("this:focus") && (e.which === 9)) {
    e.preventDefault();
    jQuery(this).blur();
    jQuery('#main-menu ul:first li:first a').focus();
  }
});

jQuery('button.close-menu').on('keydown', function (event) {
  if (event.shiftKey && event.keyCode == 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('#main-menu ul:last li:last a').focus();
  }
})

jQuery('#main-menu ul:first li:first a').on('keydown', function (event) {
  if (event.shiftKey && event.keyCode == 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('button.close-menu').focus();
  }
})

jQuery(document).ready(function() {
  window.addEventListener('load', (event) => {
      jQuery(".loader").delay(2000).fadeOut("slow");
  });
})
/* ===============================================
  Scroll Top //
============================================= */

jQuery(window).scroll(function () {
  if (jQuery(this).scrollTop() > 100) {
      jQuery('.scroll-up').fadeIn();
  } else {
      jQuery('.scroll-up').fadeOut();
  }
});

jQuery('a[href="#tobottom"]').click(function () {
  jQuery('html, body').animate({scrollTop: 0}, 'slow');
  return false;
});

(function( $ ) {
  $(window).scroll(function(){
      var sticky = $('.sticky-header'),
      scroll = $(window).scrollTop();

      if (scroll >= 100) sticky.addClass('fixed-header');
      else sticky.removeClass('fixed-header');
    });
  })( jQuery );

/* ===============================================
 Collapse Sidebar Options //
============================================= */

jQuery(document).ready(function () {
	
	function photo_gallery_search_loop_focus(element) {
		var photo_gallery_focus = element.find('select, input, textarea, button, a[href] , a');
		var photo_gallery_firstFocus = photo_gallery_focus[0];  
		var photo_gallery_lastFocus = photo_gallery_focus[photo_gallery_focus.length - 1];
		var KEYCODE_TAB = 9;

		element.on('keydown', function photo_gallery_search_loop_focus(e) {
			var isTabPressed = (e.key === 'Tab' || e.keyCode === KEYCODE_TAB);

			if (!isTabPressed) {
			  return; 
			}

			if ( e.shiftKey ) /* shift + tab */ {
			  if (document.activeElement === photo_gallery_firstFocus) {
		    photo_gallery_lastFocus.focus();
		      e.preventDefault();
		    }
		  } else /* tab */ {
		  	if (document.activeElement === photo_gallery_lastFocus) {
		    	photo_gallery_firstFocus.focus();
		      e.preventDefault();
		    }
		  }
		});
	}

  jQuery('.toggle-btn a').click(function(){
    jQuery(".header-sidebar").addClass('show');
    photo_gallery_search_loop_focus(jQuery('.header-sidebar'));
  });

  jQuery('.header-sidebar .close-pop a').click(function(){
    jQuery(".header-sidebar").removeClass('show');
  });

});
/* ===============================================
  Custom Cursor
============================================= */

const photo_gallery_customCursor = {
  init: function () {
    this.photo_gallery_customCursor();
  },
  isVariableDefined: function (el) {
    return typeof el !== "undefined" && el !== null;
  },
  select: function (selectors) {
    return document.querySelector(selectors);
  },
  selectAll: function (selectors) {
    return document.querySelectorAll(selectors);
  },
  photo_gallery_customCursor: function () {
    const photo_gallery_cursorDot = this.select(".cursor-point");
    const photo_gallery_cursorOutline = this.select(".cursor-point-outline");
    if (this.isVariableDefined(photo_gallery_cursorDot) && this.isVariableDefined(photo_gallery_cursorOutline)) {
      const cursor = {
        delay: 8,
        _x: 0,
        _y: 0,
        endX: window.innerWidth / 2,
        endY: window.innerHeight / 2,
        cursorVisible: true,
        cursorEnlarged: false,
        $dot: photo_gallery_cursorDot,
        $outline: photo_gallery_cursorOutline,

        init: function () {
          this.dotSize = this.$dot.offsetWidth;
          this.outlineSize = this.$outline.offsetWidth;
          this.setupEventListeners();
          this.animateDotOutline();
        },

        updateCursor: function (e) {
          this.cursorVisible = true;
          this.toggleCursorVisibility();
          this.endX = e.clientX;
          this.endY = e.clientY;
          this.$dot.style.top = `${this.endY}px`;
          this.$dot.style.left = `${this.endX}px`;
        },

        setupEventListeners: function () {
          window.addEventListener("load", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          photo_gallery_customCursor.selectAll("a, button").forEach((el) => {
            el.addEventListener("mouseover", () => {
              this.cursorEnlarged = true;
              this.toggleCursorSize();
            });
            el.addEventListener("mouseout", () => {
              this.cursorEnlarged = false;
              this.toggleCursorSize();
            });
          });

          document.addEventListener("mousedown", () => {
            this.cursorEnlarged = true;
            this.toggleCursorSize();
          });
          document.addEventListener("mouseup", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          document.addEventListener("mousemove", (e) => {
            this.updateCursor(e);
          });

          document.addEventListener("mouseenter", () => {
            this.cursorVisible = true;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          });

          document.addEventListener("mouseleave", () => {
            this.cursorVisible = false;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          });
        },

        animateDotOutline: function () {
          this._x += (this.endX - this._x) / this.delay;
          this._y += (this.endY - this._y) / this.delay;
          this.$outline.style.top = `${this._y}px`;
          this.$outline.style.left = `${this._x}px`;

          requestAnimationFrame(this.animateDotOutline.bind(this));
        },

        toggleCursorSize: function () {
          if (this.cursorEnlarged) {
            this.$dot.style.transform = "translate(-50%, -50%) scale(0.75)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1.6)";
          } else {
            this.$dot.style.transform = "translate(-50%, -50%) scale(1)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1)";
          }
        },

        toggleCursorVisibility: function () {
          if (this.cursorVisible) {
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          } else {
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          }
        },
      };
      cursor.init();
    }
  },
};
photo_gallery_customCursor.init(); 
/* ===============================================
  Progress Bar
============================================= */
const photo_gallery_progressBar = {
  init: function () {
      let photo_gallery_progressBarDiv = document.getElementById("elemento-progress-bar");

      if (photo_gallery_progressBarDiv) {
          let photo_gallery_body = document.body;
          let photo_gallery_rootElement = document.documentElement;

          window.addEventListener("scroll", function (event) {
              let photo_gallery_winScroll = photo_gallery_body.scrollTop || photo_gallery_rootElement.scrollTop;
              let photo_gallery_height =
              photo_gallery_rootElement.scrollHeight - photo_gallery_rootElement.clientHeight;
              let photo_gallery_scrolled = (photo_gallery_winScroll / photo_gallery_height) * 100;
              photo_gallery_progressBarDiv.style.width = photo_gallery_scrolled + "%";
          });
      }
  },
};
photo_gallery_progressBar.init();

/* ===============================================
   sticky copyright
============================================= */

window.addEventListener('scroll', function() {
  var photo_gallery_footer = document.querySelector('.sticky-copyright');
  if (!photo_gallery_footer) return; 

  var photo_gallery_scrollTop = window.scrollY || document.documentElement.photo_gallery_scrollTop;

  if (photo_gallery_scrollTop >= 100) {
    photo_gallery_footer.classList.add('active-sticky');
  }
});

/* ===============================================
   sticky sidebar
============================================= */

window.addEventListener('scroll', function () {
  var photo_gallery_sidebar = document.querySelector('.sidebar-sticky');
  if (!photo_gallery_sidebar) return;

  var photo_gallery_scrollTop = window.scrollY || document.documentElement.scrollTop;
  var photo_gallery_windowHeight = window.innerHeight;
  var photo_gallery_documentHeight = document.documentElement.scrollHeight;

  var photo_gallery_isBottom = photo_gallery_scrollTop + photo_gallery_windowHeight >= photo_gallery_documentHeight - 100;

  if (photo_gallery_scrollTop >= 100 && !photo_gallery_isBottom) {
    photo_gallery_sidebar.classList.add('sidebar-fixed');
  } else {
    photo_gallery_sidebar.classList.remove('sidebar-fixed');
  }
});